# ---------------------------------------------------------------------
#
# Copyright (c) CREATIS (Centre de Recherche en Acquisition et Traitement de l'Image 
#                        pour la Santé)
# Authors : Eduardo Davila, Frederic Cervenansky, Claire Mouton
#
#  This software is governed by the CeCILL-B license under French law and 
#  abiding by the rules of distribution of free software. You can  use, 
#  modify and/ or redistribute the software under the terms of the CeCILL-B 
#  license as circulated by CEA, CNRS and INRIA at the following URL 
#  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
#  or in the file LICENSE.txt.
#
#  As a counterpart to the access to the source code and  rights to copy,
#  modify and redistribute granted by the license, users are provided only
#  with a limited warranty  and the software's author,  the holder of the
#  economic rights,  and the successive licensors  have only  limited
#  liability. 
#
#  The fact that you are presently reading this means that you have had
#  knowledge of the CeCILL-B license and that you accept its terms.
# ------------------------------------------------------------------------  


#!/bin/bash

# JPR 2/5/2011
#if [ $UID = 0 ] 
#then
  # Set all local variables
  source $PWD/scripts/CreaTools-configure.sh
  source $PWD/scripts/CreaTools-names.sh
 
  if [ -e $generationdir ]
  then
     if [ ! -e $generationdir/creatools_install ]
     then
     	mkdir -p $generationdir/creatools_install
     fi
  else
   echo
   echo "..ERROR.."
   echo "==================================================="
   echo "REMEMBER !"
   echo ""
   echo "You MUST load the Creatools sources before (use 2.2)!"
   echo "==================================================="
   echo
   echo 
   read a
   exit 0 
  fi  
  
  cd $scriptDir
  export baseLibraryCreatoolsDir=$installPrefix/share/creatools
  mkdir -p $baseLibraryCreatoolsDir
  cp CreaTools-bashrc.sh $baseLibraryCreatoolsDir/.
  cp LocalFunctions.sh $baseLibraryCreatoolsDir/.

  #create creatools_base_library_config.sh  at the very begining, so we can write "export xxx_BIN=..." inside installmod.sh. JPRx 3 mars 2011
  echo '## This file is call from .bashrc' > $baseLibraryCreatoolsDir/creatools_base_library_config.sh
  bash installmodBash.sh $installPrefix

  # JPR 2/5/2011
  #  modify /etc/bashrc (we cannot modify .bashrc, since we switched as root)  
  # - add line 'bash $installPrefix/creatools_install/share/creatools_base_library_config.sh'

  bash installmod.sh $buildType $creasource                   $generationdir  $installPrefix
  bash installmod.sh $buildType $bbtksource                   $generationdir  $installPrefix
  bash installmod.sh $buildType $creavtksource                $generationdir  $installPrefix
  bash installmod.sh $buildType $creamaracassource            $generationdir  $installPrefix
  bash installmod.sh $buildType $creaenvironmentsource        $generationdir  $installPrefix
  bash installmod.sh $buildType $creabrukersource             $generationdir  $installPrefix
  bash installmod.sh $buildType $creaimagesource              $generationdir  $installPrefix
  bash installmod.sh $buildType $creacontourssource           $generationdir  $installPrefix
  bash installmod.sh $buildType $crearigidregistrationssource $generationdir  $installPrefix
  bash installmod.sh $buildType $bbtkgeditorsource            $generationdir  $installPrefix
  bash installmod.sh $buildType $creatoolssource              $generationdir  $installPrefix
  bash installmod.sh $buildType $creaminitoolssource          $generationdir  $installPrefix
  # bash installmod.sh $buildType $libidosource                 $generationdir  $installPrefix 

  #export as well bbPackages_DIR // JPR 25 Mai 2011

  bash installmodNomake.sh $buildType appli              $generationdir  $installPrefix
  bash installmodNomake.sh $buildType creaMiniToolsBase  $generationdir  $installPrefix
  bash installmodNomake.sh $buildType demo               $generationdir  $installPrefix
  bash installmodNomake.sh $buildType gdcmvtk            $generationdir  $installPrefix
  bash installmodNomake.sh $buildType itk                $generationdir  $installPrefix
  bash installmodNomake.sh $buildType itkvtk             $generationdir  $installPrefix
  bash installmodNomake.sh $buildType qt                 $generationdir  $installPrefix
  bash installmodNomake.sh $buildType std                $generationdir  $installPrefix
  bash installmodNomake.sh $buildType toolsbbtk          $generationdir  $installPrefix
  bash installmodNomake.sh $buildType vtk                $generationdir  $installPrefix
  bash installmodNomake.sh $buildType wx                 $generationdir  $installPrefix
  bash installmodNomake.sh $buildType wxvtk              $generationdir  $installPrefix

  source CreaTools-bashrc.sh
  source $ETC_BASHRC 

##EED 21/12/2014
##EED echo "==================================================="
##EED echo " Regenerate Package doc"
##EED $installPrefix/bin/bbRegeneratePackageDoc -a -q
##EED echo " Regenerate Boxes list"
##EED $installPrefix/bin/bbRegenerateBoxesLists -q
##EED echo "==================================================="

  # JPR 2/5/2011
#else
#  echo
#  echo "..ERROR.."
#  echo "==================================================="
#  echo "REMEMBER !"
#  echo ""
#  echo "YOU NEED TO RUN THIS ONE AS root"
#  echo "==================================================="
#  echo
#  echo
#fi 

